package org.eclipse.jdt.core.compiler;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.Arrays;
import org.eclipse.jdt.internal.compiler.parser.ScannerHelper;

public final class CharOperation {
  public static final char[] NO_CHAR = new char[0];
  
  public static final char[][] NO_CHAR_CHAR = new char[0][];
  
  public static final String[] NO_STRINGS = new String[0];
  
  public static final char[] append(char[] array, char suffix) {
    if (array == null)
      return new char[] { suffix }; 
    int length = array.length;
    System.arraycopy(array, 0, array = new char[length + 1], 0, length);
    array[length] = suffix;
    return array;
  }
  
  public static final char[] append(char[] target, char[] suffix) {
    if (suffix == null || suffix.length == 0)
      return target; 
    int targetLength = target.length;
    int subLength = suffix.length;
    int newTargetLength = targetLength + subLength;
    if (newTargetLength > targetLength)
      System.arraycopy(target, 0, target = new char[newTargetLength], 0, targetLength); 
    System.arraycopy(suffix, 0, target, targetLength, subLength);
    return target;
  }
  
  public static final char[] append(char[] target, int index, char[] array, int start, int end) {
    int targetLength = target.length;
    int subLength = end - start;
    int newTargetLength = subLength + index;
    if (newTargetLength > targetLength)
      System.arraycopy(target, 0, target = new char[newTargetLength * 2], 0, index); 
    System.arraycopy(array, start, target, index, subLength);
    return target;
  }
  
  public static final char[][] arrayConcat(char[][] first, char[][] second) {
    if (first == null)
      return second; 
    if (second == null)
      return first; 
    int length1 = first.length;
    int length2 = second.length;
    char[][] result = new char[length1 + length2][];
    System.arraycopy(first, 0, result, 0, length1);
    System.arraycopy(second, 0, result, length1, length2);
    return result;
  }
  
  public static final boolean camelCaseMatch(char[] pattern, char[] name) {
    if (pattern == null)
      return true; 
    if (name == null)
      return false; 
    return camelCaseMatch(pattern, 0, pattern.length, name, 0, name.length, false);
  }
  
  public static final boolean camelCaseMatch(char[] pattern, char[] name, boolean samePartCount) {
    if (pattern == null)
      return true; 
    if (name == null)
      return false; 
    return camelCaseMatch(pattern, 0, pattern.length, name, 0, name.length, samePartCount);
  }
  
  public static final boolean camelCaseMatch(char[] pattern, int patternStart, int patternEnd, char[] name, int nameStart, int nameEnd) {
    return camelCaseMatch(pattern, patternStart, patternEnd, name, nameStart, nameEnd, false);
  }
  
  public static final boolean camelCaseMatch(char[] pattern, int patternStart, int patternEnd, char[] name, int nameStart, int nameEnd, boolean samePartCount) {
    if (name == null)
      return false; 
    if (pattern == null)
      return true; 
    if (patternEnd < 0)
      patternEnd = pattern.length; 
    if (nameEnd < 0)
      nameEnd = name.length; 
    if (patternEnd <= patternStart)
      return (nameEnd <= nameStart); 
    if (nameEnd <= nameStart)
      return false; 
    if (name[nameStart] != pattern[patternStart])
      return false; 
    int iPattern = patternStart;
    int iName = nameStart;
    label77: while (true) {
      char nameChar;
      iPattern++;
      iName++;
      if (iPattern == patternEnd) {
        if (!samePartCount || iName == nameEnd)
          return true; 
        while (true) {
          if (iName == nameEnd)
            return true; 
          nameChar = name[iName];
          if (nameChar < '') {
            if ((ScannerHelper.OBVIOUS_IDENT_CHAR_NATURES[nameChar] & 0x20) != 0)
              return false; 
          } else if (!Character.isJavaIdentifierPart(nameChar) || Character.isUpperCase(nameChar)) {
            return false;
          } 
          iName++;
        } 
        break;
      } 
      if (iName == nameEnd)
        return false; 
      char patternChar;
      if ((patternChar = pattern[iPattern]) == name[iName])
        continue; 
      if (patternChar < '') {
        if ((ScannerHelper.OBVIOUS_IDENT_CHAR_NATURES[patternChar] & 0x24) == 0)
          return false; 
      } else if (Character.isJavaIdentifierPart(patternChar) && !Character.isUpperCase(patternChar) && !Character.isDigit(patternChar)) {
        return false;
      } 
      while (true) {
        if (iName == nameEnd)
          return false; 
        nameChar = name[iName];
        if (nameChar < '') {
          int charNature = ScannerHelper.OBVIOUS_IDENT_CHAR_NATURES[nameChar];
          if ((charNature & 0x90) != 0) {
            iName++;
            continue;
          } 
          if ((charNature & 0x4) != 0) {
            if (patternChar == nameChar)
              continue label77; 
            iName++;
            continue;
          } 
          if (patternChar != nameChar)
            return false; 
          continue label77;
        } 
        if (Character.isJavaIdentifierPart(nameChar) && !Character.isUpperCase(nameChar)) {
          iName++;
          continue;
        } 
        if (Character.isDigit(nameChar)) {
          if (patternChar == nameChar)
            continue label77; 
          iName++;
          continue;
        } 
        break;
      } 
      if (patternChar != nameChar)
        return false; 
    } 
  }
  
  public static final boolean substringMatch(String pattern, String name) {
    if (pattern == null || pattern.length() == 0)
      return true; 
    if (name == null)
      return false; 
    return checkSubstringMatch(pattern.toCharArray(), name.toCharArray());
  }
  
  public static final boolean substringMatch(char[] pattern, char[] name) {
    if (pattern == null || pattern.length == 0)
      return true; 
    if (name == null)
      return false; 
    return checkSubstringMatch(pattern, name);
  }
  
  private static final boolean checkSubstringMatch(char[] pattern, char[] name) {
    for (int nidx = 0; nidx < name.length - pattern.length + 1; nidx++) {
      for (int pidx = 0; pidx < pattern.length; pidx++) {
        if (Character.toLowerCase(name[nidx + pidx]) != 
          Character.toLowerCase(pattern[pidx])) {
          if (name[nidx + pidx] == '(' || name[nidx + pidx] == ':')
            return false; 
          break;
        } 
        if (pidx == pattern.length - 1)
          return true; 
      } 
    } 
    return false;
  }
  
  public static String[] charArrayToStringArray(char[][] charArrays) {
    if (charArrays == null)
      return null; 
    int length = charArrays.length;
    if (length == 0)
      return NO_STRINGS; 
    String[] strings = new String[length];
    for (int i = 0; i < length; i++)
      strings[i] = new String(charArrays[i]); 
    return strings;
  }
  
  public static String charToString(char[] charArray) {
    if (charArray == null)
      return null; 
    return new String(charArray);
  }
  
  public static final char[][] arrayConcat(char[][] first, char[] second) {
    if (second == null)
      return first; 
    if (first == null)
      return new char[][] { second }; 
    int length = first.length;
    char[][] result = new char[length + 1][];
    System.arraycopy(first, 0, result, 0, length);
    result[length] = second;
    return result;
  }
  
  public static final int compareTo(char[] array1, char[] array2) {
    int length1 = array1.length;
    int length2 = array2.length;
    int min = Math.min(length1, length2);
    for (int i = 0; i < min; i++) {
      if (array1[i] != array2[i])
        return array1[i] - array2[i]; 
    } 
    return length1 - length2;
  }
  
  public static final int compareTo(char[] array1, char[] array2, int start, int end) {
    int length1 = array1.length;
    int length2 = array2.length;
    int min = Math.min(length1, length2);
    min = Math.min(min, end);
    for (int i = start; i < min; i++) {
      if (array1[i] != array2[i])
        return array1[i] - array2[i]; 
    } 
    return length1 - length2;
  }
  
  public static final int compareWith(char[] array, char[] prefix) {
    int arrayLength = array.length;
    int prefixLength = prefix.length;
    int min = Math.min(arrayLength, prefixLength);
    int i = 0;
    while (min-- != 0) {
      char c1 = array[i];
      char c2 = prefix[i++];
      if (c1 != c2)
        return c1 - c2; 
    } 
    if (prefixLength == i)
      return 0; 
    return -1;
  }
  
  public static final char[] concat(char[] first, char[] second) {
    if (first == null)
      return second; 
    if (second == null)
      return first; 
    int length1 = first.length;
    int length2 = second.length;
    char[] result = new char[length1 + length2];
    System.arraycopy(first, 0, result, 0, length1);
    System.arraycopy(second, 0, result, length1, length2);
    return result;
  }
  
  public static final char[] concat(char[] first, char[] second, char[] third) {
    if (first == null)
      return concat(second, third); 
    if (second == null)
      return concat(first, third); 
    if (third == null)
      return concat(first, second); 
    int length1 = first.length;
    int length2 = second.length;
    int length3 = third.length;
    char[] result = new char[length1 + length2 + length3];
    System.arraycopy(first, 0, result, 0, length1);
    System.arraycopy(second, 0, result, length1, length2);
    System.arraycopy(third, 0, result, length1 + length2, length3);
    return result;
  }
  
  public static final char[] concat(char[] first, char[] second, char separator) {
    if (first == null)
      return second; 
    if (second == null)
      return first; 
    int length1 = first.length;
    if (length1 == 0)
      return second; 
    int length2 = second.length;
    if (length2 == 0)
      return first; 
    char[] result = new char[length1 + length2 + 1];
    System.arraycopy(first, 0, result, 0, length1);
    result[length1] = separator;
    System.arraycopy(second, 0, result, length1 + 1, length2);
    return result;
  }
  
  public static final char[] concat(char[] first, char sep1, char[] second, char sep2, char[] third) {
    if (first == null)
      return concat(second, third, sep2); 
    if (second == null)
      return concat(first, third, sep1); 
    if (third == null)
      return concat(first, second, sep1); 
    int length1 = first.length;
    int length2 = second.length;
    int length3 = third.length;
    char[] result = new char[length1 + length2 + length3 + 2];
    System.arraycopy(first, 0, result, 0, length1);
    result[length1] = sep1;
    System.arraycopy(second, 0, result, length1 + 1, length2);
    result[length1 + length2 + 1] = sep2;
    System.arraycopy(third, 0, result, length1 + length2 + 2, length3);
    return result;
  }
  
  public static final char[] concatNonEmpty(char[] first, char[] second, char separator) {
    if (first == null || first.length == 0)
      return second; 
    if (second == null || second.length == 0)
      return first; 
    return concat(first, second, separator);
  }
  
  public static final char[] concatNonEmpty(char[] first, char sep1, char[] second, char sep2, char[] third) {
    if (first == null || first.length == 0)
      return concatNonEmpty(second, third, sep2); 
    if (second == null || second.length == 0)
      return concatNonEmpty(first, third, sep1); 
    if (third == null || third.length == 0)
      return concatNonEmpty(first, second, sep1); 
    return concat(first, sep1, second, sep2, third);
  }
  
  public static final char[] concat(char prefix, char[] array, char suffix) {
    if (array == null)
      return new char[] { prefix, suffix }; 
    int length = array.length;
    char[] result = new char[length + 2];
    result[0] = prefix;
    System.arraycopy(array, 0, result, 1, length);
    result[length + 1] = suffix;
    return result;
  }
  
  public static final char[] concatWith(char[] name, char[][] array, char separator) {
    int nameLength = (name == null) ? 0 : name.length;
    if (nameLength == 0)
      return concatWith(array, separator); 
    int length = (array == null) ? 0 : array.length;
    if (length == 0)
      return name; 
    int size = nameLength;
    int index = length;
    while (--index >= 0) {
      if ((array[index]).length > 0)
        size += (array[index]).length + 1; 
    } 
    char[] result = new char[size];
    index = size;
    for (int i = length - 1; i >= 0; i--) {
      int subLength = (array[i]).length;
      if (subLength > 0) {
        index -= subLength;
        System.arraycopy(array[i], 0, result, index, subLength);
        result[--index] = separator;
      } 
    } 
    System.arraycopy(name, 0, result, 0, nameLength);
    return result;
  }
  
  public static final char[] concatWith(char[][] array, char[] name, char separator) {
    int nameLength = (name == null) ? 0 : name.length;
    if (nameLength == 0)
      return concatWith(array, separator); 
    int length = (array == null) ? 0 : array.length;
    if (length == 0)
      return name; 
    int size = nameLength;
    int index = length;
    while (--index >= 0) {
      if ((array[index]).length > 0)
        size += (array[index]).length + 1; 
    } 
    char[] result = new char[size];
    index = 0;
    for (int i = 0; i < length; i++) {
      int subLength = (array[i]).length;
      if (subLength > 0) {
        System.arraycopy(array[i], 0, result, index, subLength);
        index += subLength;
        result[index++] = separator;
      } 
    } 
    System.arraycopy(name, 0, result, index, nameLength);
    return result;
  }
  
  public static final char[] concatWith(char[][] array, char separator) {
    int length = (array == null) ? 0 : array.length;
    if (length == 0)
      return NO_CHAR; 
    int size = length - 1;
    int index = length;
    while (--index >= 0) {
      if ((array[index]).length == 0) {
        size--;
        continue;
      } 
      size += (array[index]).length;
    } 
    if (size <= 0)
      return NO_CHAR; 
    char[] result = new char[size];
    index = length;
    while (--index >= 0) {
      length = (array[index]).length;
      if (length > 0) {
        System.arraycopy(
            array[index], 
            0, 
            result, 
            size -= length, 
            length);
        if (--size >= 0)
          result[size] = separator; 
      } 
    } 
    return result;
  }
  
  public static final char[] concatWithAll(char[][] array, char separator) {
    int length = (array == null) ? 0 : array.length;
    if (length == 0)
      return NO_CHAR; 
    int size = length - 1;
    int index = length;
    while (--index >= 0)
      size += (array[index]).length; 
    char[] result = new char[size];
    index = length;
    while (--index >= 0) {
      length = (array[index]).length;
      if (length > 0)
        System.arraycopy(
            array[index], 
            0, 
            result, 
            size -= length, 
            length); 
      if (--size >= 0)
        result[size] = separator; 
    } 
    return result;
  }
  
  public static final boolean contains(char character, char[][] array) {
    for (int i = array.length; --i >= 0; ) {
      char[] subarray = array[i];
      for (int j = subarray.length; --j >= 0;) {
        if (subarray[j] == character)
          return true; 
      } 
    } 
    return false;
  }
  
  public static final boolean contains(char character, char[] array) {
    for (int i = array.length; --i >= 0;) {
      if (array[i] == character)
        return true; 
    } 
    return false;
  }
  
  public static final boolean contains(char[] characters, char[] array) {
    for (int i = array.length; --i >= 0;) {
      for (int j = characters.length; --j >= 0;) {
        if (array[i] == characters[j])
          return true; 
      } 
    } 
    return false;
  }
  
  public static final char[][] deepCopy(char[][] toCopy) {
    int toCopyLength = toCopy.length;
    char[][] result = new char[toCopyLength][];
    for (int i = 0; i < toCopyLength; i++) {
      char[] toElement = toCopy[i];
      int toElementLength = toElement.length;
      char[] resultElement = new char[toElementLength];
      System.arraycopy(toElement, 0, resultElement, 0, toElementLength);
      result[i] = resultElement;
    } 
    return result;
  }
  
  public static final boolean endsWith(char[] array, char[] toBeFound) {
    int i = toBeFound.length;
    int j = array.length - i;
    if (j < 0)
      return false; 
    while (--i >= 0) {
      if (toBeFound[i] != array[i + j])
        return false; 
    } 
    return true;
  }
  
  public static final boolean equals(char[][] first, char[][] second) {
    if (first == second)
      return true; 
    if (first == null || second == null)
      return false; 
    if (first.length != second.length)
      return false; 
    for (int i = first.length; --i >= 0;) {
      if (!equals(first[i], second[i]))
        return false; 
    } 
    return true;
  }
  
  public static final boolean equals(char[][] first, char[][] second, boolean isCaseSensitive) {
    if (isCaseSensitive)
      return equals(first, second); 
    if (first == second)
      return true; 
    if (first == null || second == null)
      return false; 
    if (first.length != second.length)
      return false; 
    for (int i = first.length; --i >= 0;) {
      if (!equals(first[i], second[i], false))
        return false; 
    } 
    return true;
  }
  
  public static final boolean equals(char[] first, char[] second) {
    if (first == second)
      return true; 
    if (first == null || second == null)
      return false; 
    if (first.length != second.length)
      return false; 
    for (int i = first.length; --i >= 0;) {
      if (first[i] != second[i])
        return false; 
    } 
    return true;
  }
  
  public static final boolean equals(char[] first, char[] second, int secondStart, int secondEnd) {
    return equals(first, second, secondStart, secondEnd, true);
  }
  
  public static final boolean equals(char[] first, char[] second, int secondStart, int secondEnd, boolean isCaseSensitive) {
    if (first == second)
      return true; 
    if (first == null || second == null)
      return false; 
    if (first.length != secondEnd - secondStart)
      return false; 
    if (isCaseSensitive) {
      for (int i = first.length; --i >= 0;) {
        if (first[i] != second[i + secondStart])
          return false; 
      } 
    } else {
      for (int i = first.length; --i >= 0;) {
        if (ScannerHelper.toLowerCase(first[i]) != ScannerHelper.toLowerCase(second[i + secondStart]))
          return false; 
      } 
    } 
    return true;
  }
  
  public static final boolean equals(char[] first, char[] second, boolean isCaseSensitive) {
    if (isCaseSensitive)
      return equals(first, second); 
    if (first == second)
      return true; 
    if (first == null || second == null)
      return false; 
    if (first.length != second.length)
      return false; 
    for (int i = first.length; --i >= 0;) {
      if (ScannerHelper.toLowerCase(first[i]) != 
        ScannerHelper.toLowerCase(second[i]))
        return false; 
    } 
    return true;
  }
  
  public static final boolean fragmentEquals(char[] fragment, char[] name, int startIndex, boolean isCaseSensitive) {
    int max = fragment.length;
    if (name.length < max + startIndex)
      return false; 
    if (isCaseSensitive) {
      for (int j = max; 
        --j >= 0;) {
        if (fragment[j] != name[j + startIndex])
          return false; 
      } 
      return true;
    } 
    for (int i = max; 
      --i >= 0;) {
      if (ScannerHelper.toLowerCase(fragment[i]) != 
        ScannerHelper.toLowerCase(name[i + startIndex]))
        return false; 
    } 
    return true;
  }
  
  public static final int hashCode(char[] array) {
    int hash = Arrays.hashCode(array);
    return hash & Integer.MAX_VALUE;
  }
  
  public static boolean isWhitespace(char c) {
    return (c < '' && (ScannerHelper.OBVIOUS_IDENT_CHAR_NATURES[c] & 0x100) != 0);
  }
  
  public static final int indexOf(char toBeFound, char[] array) {
    return indexOf(toBeFound, array, 0);
  }
  
  public static final int indexOf(char[] toBeFound, char[] array, boolean isCaseSensitive) {
    return indexOf(toBeFound, array, isCaseSensitive, 0);
  }
  
  public static final int indexOf(char[] toBeFound, char[] array, boolean isCaseSensitive, int start) {
    return indexOf(toBeFound, array, isCaseSensitive, start, array.length);
  }
  
  public static final int indexOf(char[] toBeFound, char[] array, boolean isCaseSensitive, int start, int end) {
    int arrayLength = end;
    int toBeFoundLength = toBeFound.length;
    if (toBeFoundLength > arrayLength || start < 0)
      return -1; 
    if (toBeFoundLength == 0)
      return 0; 
    if (toBeFoundLength == arrayLength) {
      if (isCaseSensitive) {
        for (int j = start; j < arrayLength; j++) {
          if (array[j] != toBeFound[j])
            return -1; 
        } 
        return 0;
      } 
      for (int i = start; i < arrayLength; i++) {
        if (ScannerHelper.toLowerCase(array[i]) != ScannerHelper.toLowerCase(toBeFound[i]))
          return -1; 
      } 
      return 0;
    } 
    if (isCaseSensitive) {
      for (int i = start, max = arrayLength - toBeFoundLength + 1; i < max; i++) {
        if (array[i] == toBeFound[0]) {
          int j = 1;
          while (true) {
            if (j >= toBeFoundLength)
              return i; 
            if (array[i + j] != toBeFound[j])
              break; 
            j++;
          } 
        } 
      } 
    } else {
      for (int i = start, max = arrayLength - toBeFoundLength + 1; i < max; i++) {
        if (ScannerHelper.toLowerCase(array[i]) == ScannerHelper.toLowerCase(toBeFound[0])) {
          int j = 1;
          while (true) {
            if (j >= toBeFoundLength)
              return i; 
            if (ScannerHelper.toLowerCase(array[i + j]) != ScannerHelper.toLowerCase(toBeFound[j]))
              break; 
            j++;
          } 
        } 
      } 
    } 
    return -1;
  }
  
  public static final int indexOf(char toBeFound, char[] array, int start) {
    for (int i = start; i < array.length; i++) {
      if (toBeFound == array[i])
        return i; 
    } 
    return -1;
  }
  
  public static final int indexOf(char toBeFound, char[] array, int start, int end) {
    for (int i = start; i < end; i++) {
      if (toBeFound == array[i])
        return i; 
    } 
    return -1;
  }
  
  public static final int lastIndexOf(char toBeFound, char[] array) {
    for (int i = array.length; --i >= 0;) {
      if (toBeFound == array[i])
        return i; 
    } 
    return -1;
  }
  
  public static final int lastIndexOf(char toBeFound, char[] array, int startIndex) {
    for (int i = array.length; --i >= startIndex;) {
      if (toBeFound == array[i])
        return i; 
    } 
    return -1;
  }
  
  public static final int lastIndexOf(char toBeFound, char[] array, int startIndex, int endIndex) {
    for (int i = endIndex; --i >= startIndex;) {
      if (toBeFound == array[i])
        return i; 
    } 
    return -1;
  }
  
  public static final char[] lastSegment(char[] array, char separator) {
    int pos = lastIndexOf(separator, array);
    if (pos < 0)
      return array; 
    return subarray(array, pos + 1, array.length);
  }
  
  public static final boolean match(char[] pattern, char[] name, boolean isCaseSensitive) {
    if (name == null)
      return false; 
    if (pattern == null)
      return true; 
    return match(
        pattern, 
        0, 
        pattern.length, 
        name, 
        0, 
        name.length, 
        isCaseSensitive);
  }
  
  public static final boolean match(char[] pattern, int patternStart, int patternEnd, char[] name, int nameStart, int nameEnd, boolean isCaseSensitive) {
    int segmentStart;
    if (name == null)
      return false; 
    if (pattern == null)
      return true; 
    int iPattern = patternStart;
    int iName = nameStart;
    if (patternEnd < 0)
      patternEnd = pattern.length; 
    if (nameEnd < 0)
      nameEnd = name.length; 
    char patternChar = Character.MIN_VALUE;
    while (true) {
      if (iPattern == patternEnd) {
        if (iName == nameEnd)
          return true; 
        return false;
      } 
      if ((patternChar = pattern[iPattern]) == '*')
        break; 
      if (iName == nameEnd)
        return false; 
      if (patternChar != (
        isCaseSensitive ? 
        name[iName] : 
        ScannerHelper.toLowerCase(name[iName])))
        if (patternChar != '?')
          return false;  
      iName++;
      iPattern++;
    } 
    if (patternChar == '*') {
      segmentStart = ++iPattern;
    } else {
      segmentStart = 0;
    } 
    int prefixStart = iName;
    while (iName < nameEnd) {
      if (iPattern == patternEnd) {
        iPattern = segmentStart;
        iName = ++prefixStart;
        continue;
      } 
      if ((patternChar = pattern[iPattern]) == '*') {
        segmentStart = ++iPattern;
        if (segmentStart == patternEnd)
          return true; 
        prefixStart = iName;
        continue;
      } 
      if ((isCaseSensitive ? name[iName] : ScannerHelper.toLowerCase(name[iName])) != 
        patternChar)
        if (patternChar != '?') {
          iPattern = segmentStart;
          iName = ++prefixStart;
          continue;
        }  
      iName++;
      iPattern++;
    } 
    return !(segmentStart != patternEnd && (
      iName != nameEnd || iPattern != patternEnd) && (
      iPattern != patternEnd - 1 || pattern[iPattern] != '*'));
  }
  
  public static final boolean pathMatch(char[] pattern, char[] filepath, boolean isCaseSensitive, char pathSeparator) {
    int fSegmentStart, pSegmentRestart;
    if (filepath == null)
      return false; 
    if (pattern == null)
      return true; 
    int pSegmentStart = (pattern[0] == pathSeparator) ? 1 : 0;
    int pLength = pattern.length;
    int pSegmentEnd = indexOf(pathSeparator, pattern, pSegmentStart + 1);
    if (pSegmentEnd < 0)
      pSegmentEnd = pLength; 
    boolean freeTrailingDoubleStar = (pattern[pLength - 1] == pathSeparator);
    int fLength = filepath.length;
    if (filepath[0] != pathSeparator) {
      fSegmentStart = 0;
    } else {
      fSegmentStart = 1;
    } 
    if (fSegmentStart != pSegmentStart)
      return false; 
    int fSegmentEnd = indexOf(pathSeparator, filepath, fSegmentStart + 1);
    if (fSegmentEnd < 0)
      fSegmentEnd = fLength; 
    while (pSegmentStart < pLength && (
      pSegmentEnd != pLength || !freeTrailingDoubleStar) && (
      pSegmentEnd != pSegmentStart + 2 || 
      pattern[pSegmentStart] != '*' || 
      pattern[pSegmentStart + 1] != '*')) {
      if (fSegmentStart >= fLength)
        return false; 
      if (!match(
          pattern, 
          pSegmentStart, 
          pSegmentEnd, 
          filepath, 
          fSegmentStart, 
          fSegmentEnd, 
          isCaseSensitive))
        return false; 
      pSegmentEnd = 
        indexOf(
          pathSeparator, 
          pattern, 
          pSegmentStart = pSegmentEnd + 1);
      if (pSegmentEnd < 0)
        pSegmentEnd = pLength; 
      fSegmentEnd = 
        indexOf(
          pathSeparator, 
          filepath, 
          fSegmentStart = fSegmentEnd + 1);
      if (fSegmentEnd < 0)
        fSegmentEnd = fLength; 
    } 
    if ((pSegmentStart >= pLength && freeTrailingDoubleStar) || (
      pSegmentEnd == pSegmentStart + 2 && 
      pattern[pSegmentStart] == '*' && 
      pattern[pSegmentStart + 1] == '*')) {
      pSegmentEnd = 
        indexOf(
          pathSeparator, 
          pattern, 
          pSegmentStart = pSegmentEnd + 1);
      if (pSegmentEnd < 0)
        pSegmentEnd = pLength; 
      pSegmentRestart = pSegmentStart;
    } else {
      if (pSegmentStart >= pLength)
        return (fSegmentStart >= fLength); 
      pSegmentRestart = 0;
    } 
    int fSegmentRestart = fSegmentStart;
    while (fSegmentStart < fLength) {
      if (pSegmentStart >= pLength) {
        if (freeTrailingDoubleStar)
          return true; 
        pSegmentEnd = 
          indexOf(pathSeparator, pattern, pSegmentStart = pSegmentRestart);
        if (pSegmentEnd < 0)
          pSegmentEnd = pLength; 
        fSegmentRestart = 
          indexOf(pathSeparator, filepath, fSegmentRestart + 1);
        if (fSegmentRestart < 0) {
          fSegmentRestart = fLength;
        } else {
          fSegmentRestart++;
        } 
        fSegmentEnd = 
          indexOf(pathSeparator, filepath, fSegmentStart = fSegmentRestart);
        if (fSegmentEnd < 0)
          fSegmentEnd = fLength; 
        continue;
      } 
      if (pSegmentEnd == pSegmentStart + 2 && 
        pattern[pSegmentStart] == '*' && 
        pattern[pSegmentStart + 1] == '*') {
        pSegmentEnd = 
          indexOf(pathSeparator, pattern, pSegmentStart = pSegmentEnd + 1);
        if (pSegmentEnd < 0)
          pSegmentEnd = pLength; 
        pSegmentRestart = pSegmentStart;
        fSegmentRestart = fSegmentStart;
        if (pSegmentStart >= pLength)
          return true; 
        continue;
      } 
      if (!match(
          pattern, 
          pSegmentStart, 
          pSegmentEnd, 
          filepath, 
          fSegmentStart, 
          fSegmentEnd, 
          isCaseSensitive)) {
        pSegmentEnd = 
          indexOf(pathSeparator, pattern, pSegmentStart = pSegmentRestart);
        if (pSegmentEnd < 0)
          pSegmentEnd = pLength; 
        fSegmentRestart = 
          indexOf(pathSeparator, filepath, fSegmentRestart + 1);
        if (fSegmentRestart < 0) {
          fSegmentRestart = fLength;
        } else {
          fSegmentRestart++;
        } 
        fSegmentEnd = 
          indexOf(pathSeparator, filepath, fSegmentStart = fSegmentRestart);
        if (fSegmentEnd < 0)
          fSegmentEnd = fLength; 
        continue;
      } 
      pSegmentEnd = 
        indexOf(
          pathSeparator, 
          pattern, 
          pSegmentStart = pSegmentEnd + 1);
      if (pSegmentEnd < 0)
        pSegmentEnd = pLength; 
      fSegmentEnd = 
        indexOf(
          pathSeparator, 
          filepath, 
          fSegmentStart = fSegmentEnd + 1);
      if (fSegmentEnd < 0)
        fSegmentEnd = fLength; 
    } 
    return !(pSegmentRestart < pSegmentEnd && (
      fSegmentStart < fLength || pSegmentStart < pLength) && (
      pSegmentStart != pLength - 2 || 
      pattern[pSegmentStart] != '*' || 
      pattern[pSegmentStart + 1] != '*') && (
      pSegmentStart != pLength || !freeTrailingDoubleStar));
  }
  
  public static final int occurencesOf(char toBeFound, char[] array) {
    int count = 0;
    for (int i = 0; i < array.length; i++) {
      if (toBeFound == array[i])
        count++; 
    } 
    return count;
  }
  
  public static final int occurencesOf(char toBeFound, char[] array, int start) {
    int count = 0;
    for (int i = start; i < array.length; i++) {
      if (toBeFound == array[i])
        count++; 
    } 
    return count;
  }
  
  public static final int parseInt(char[] array, int start, int length) throws NumberFormatException {
    if (length == 1) {
      int result = array[start] - 48;
      if (result < 0 || result > 9)
        throw new NumberFormatException("invalid digit"); 
      return result;
    } 
    return Integer.parseInt(new String(array, start, length));
  }
  
  public static final boolean prefixEquals(char[] prefix, char[] name) {
    int max = prefix.length;
    if (name.length < max)
      return false; 
    for (int i = max; 
      --i >= 0;) {
      if (prefix[i] != name[i])
        return false; 
    } 
    return true;
  }
  
  public static final boolean prefixEquals(char[] prefix, char[] name, boolean isCaseSensitive) {
    return prefixEquals(prefix, name, isCaseSensitive, 0);
  }
  
  public static final boolean prefixEquals(char[] prefix, char[] name, boolean isCaseSensitive, int startIndex) {
    int max = prefix.length;
    if (name.length - startIndex < max)
      return false; 
    if (isCaseSensitive) {
      for (int j = max; --j >= 0;) {
        if (prefix[j] != name[startIndex + j])
          return false; 
      } 
      return true;
    } 
    for (int i = max; --i >= 0;) {
      if (ScannerHelper.toLowerCase(prefix[i]) != 
        ScannerHelper.toLowerCase(name[startIndex + i]))
        return false; 
    } 
    return true;
  }
  
  public static final char[] remove(char[] array, char toBeRemoved) {
    if (array == null)
      return null; 
    int length = array.length;
    if (length == 0)
      return array; 
    char[] result = null;
    int count = 0;
    for (int i = 0; i < length; i++) {
      char c = array[i];
      if (c == toBeRemoved) {
        if (result == null) {
          result = new char[length];
          System.arraycopy(array, 0, result, 0, i);
          count = i;
        } 
      } else if (result != null) {
        result[count++] = c;
      } 
    } 
    if (result == null)
      return array; 
    System.arraycopy(result, 0, result = new char[count], 0, count);
    return result;
  }
  
  public static final void replace(char[] array, char toBeReplaced, char replacementChar) {
    if (toBeReplaced != replacementChar)
      for (int i = 0, max = array.length; i < max; i++) {
        if (array[i] == toBeReplaced)
          array[i] = replacementChar; 
      }  
  }
  
  public static final void replace(char[] array, char[] toBeReplaced, char replacementChar) {
    replace(array, toBeReplaced, replacementChar, 0, array.length);
  }
  
  public static final void replace(char[] array, char[] toBeReplaced, char replacementChar, int start, int end) {
    for (int i = end; --i >= start;) {
      for (int j = toBeReplaced.length; --j >= 0;) {
        if (array[i] == toBeReplaced[j])
          array[i] = replacementChar; 
      } 
    } 
  }
  
  public static final char[] replace(char[] array, char[] toBeReplaced, char[] replacementChars) {
    int max = array.length;
    int replacedLength = toBeReplaced.length;
    int replacementLength = replacementChars.length;
    int[] starts = new int[5];
    int occurrenceCount = 0;
    if (!equals(toBeReplaced, replacementChars))
      for (int j = 0; j < max; ) {
        int index = indexOf(toBeReplaced, array, true, j);
        if (index == -1) {
          j++;
          continue;
        } 
        if (occurrenceCount == starts.length)
          System.arraycopy(
              starts, 
              0, 
              starts = new int[occurrenceCount * 2], 
              0, 
              occurrenceCount); 
        starts[occurrenceCount++] = index;
        j = index + replacedLength;
      }  
    if (occurrenceCount == 0)
      return array; 
    char[] result = 
      new char[max + 
        occurrenceCount * (replacementLength - replacedLength)];
    int inStart = 0, outStart = 0;
    for (int i = 0; i < occurrenceCount; i++) {
      int offset = starts[i] - inStart;
      System.arraycopy(array, inStart, result, outStart, offset);
      inStart += offset;
      outStart += offset;
      System.arraycopy(
          replacementChars, 
          0, 
          result, 
          outStart, 
          replacementLength);
      inStart += replacedLength;
      outStart += replacementLength;
    } 
    System.arraycopy(array, inStart, result, outStart, max - inStart);
    return result;
  }
  
  public static final char[] replaceOnCopy(char[] array, char toBeReplaced, char replacementChar) {
    char[] result = null;
    for (int i = 0, length = array.length; i < length; i++) {
      char c = array[i];
      if (c == toBeReplaced) {
        if (result == null) {
          result = new char[length];
          System.arraycopy(array, 0, result, 0, i);
        } 
        result[i] = replacementChar;
      } else if (result != null) {
        result[i] = c;
      } 
    } 
    if (result == null)
      return array; 
    return result;
  }
  
  public static final char[][] splitAndTrimOn(char divider, char[] array) {
    int length = (array == null) ? 0 : array.length;
    if (length == 0)
      return NO_CHAR_CHAR; 
    int wordCount = 1;
    for (int i = 0; i < length; i++) {
      if (array[i] == divider)
        wordCount++; 
    } 
    char[][] split = new char[wordCount][];
    int last = 0, currentWord = 0;
    for (int j = 0; j < length; j++) {
      if (array[j] == divider) {
        int k = last, m = j - 1;
        while (k < j && array[k] == ' ')
          k++; 
        while (m > k && array[m] == ' ')
          m--; 
        split[currentWord] = new char[m - k + 1];
        System.arraycopy(
            array, 
            k, 
            split[currentWord++], 
            0, 
            m - k + 1);
        last = j + 1;
      } 
    } 
    int start = last, end = length - 1;
    while (start < length && array[start] == ' ')
      start++; 
    while (end > start && array[end] == ' ')
      end--; 
    split[currentWord] = new char[end - start + 1];
    System.arraycopy(
        array, 
        start, 
        split[currentWord++], 
        0, 
        end - start + 1);
    return split;
  }
  
  public static final char[][] splitOn(char divider, char[] array) {
    int length = (array == null) ? 0 : array.length;
    if (length == 0)
      return NO_CHAR_CHAR; 
    int wordCount = 1;
    for (int i = 0; i < length; i++) {
      if (array[i] == divider)
        wordCount++; 
    } 
    char[][] split = new char[wordCount][];
    int last = 0, currentWord = 0;
    for (int j = 0; j < length; j++) {
      if (array[j] == divider) {
        split[currentWord] = new char[j - last];
        System.arraycopy(
            array, 
            last, 
            split[currentWord++], 
            0, 
            j - last);
        last = j + 1;
      } 
    } 
    split[currentWord] = new char[length - last];
    System.arraycopy(array, last, split[currentWord], 0, length - last);
    return split;
  }
  
  public static final char[][] splitOn(char divider, char[] array, int start, int end) {
    int length = (array == null) ? 0 : array.length;
    if (length == 0 || start > end)
      return NO_CHAR_CHAR; 
    int wordCount = 1;
    for (int i = start; i < end; i++) {
      if (array[i] == divider)
        wordCount++; 
    } 
    char[][] split = new char[wordCount][];
    int last = start, currentWord = 0;
    for (int j = start; j < end; j++) {
      if (array[j] == divider) {
        split[currentWord] = new char[j - last];
        System.arraycopy(
            array, 
            last, 
            split[currentWord++], 
            0, 
            j - last);
        last = j + 1;
      } 
    } 
    split[currentWord] = new char[end - last];
    System.arraycopy(array, last, split[currentWord], 0, end - last);
    return split;
  }
  
  public static final char[][] splitOnWithEnclosures(char divider, char openEncl, char closeEncl, char[] array, int start, int end) {
    int length = (array == null) ? 0 : array.length;
    if (length == 0 || start > end)
      return NO_CHAR_CHAR; 
    int wordCount = 1;
    int enclCount = 0;
    for (int i = start; i < end; i++) {
      if (array[i] == openEncl) {
        enclCount++;
      } else if (array[i] == divider) {
        wordCount++;
      } 
    } 
    if (enclCount == 0)
      return splitOn(divider, array, start, end); 
    int nesting = 0;
    if (openEncl == divider || closeEncl == divider)
      return NO_CHAR_CHAR; 
    int[][] splitOffsets = new int[wordCount][2];
    int last = start, currentWord = 0, prevOffset = start;
    for (int j = start; j < end; j++) {
      if (array[j] == openEncl) {
        nesting++;
      } else if (array[j] == closeEncl) {
        if (nesting > 0)
          nesting--; 
      } else if (array[j] == divider && nesting == 0) {
        splitOffsets[currentWord][0] = prevOffset;
        last = splitOffsets[currentWord++][1] = j;
        prevOffset = last + 1;
      } 
    } 
    if (last < end - 1) {
      splitOffsets[currentWord][0] = prevOffset;
      splitOffsets[currentWord++][1] = end;
    } 
    char[][] split = new char[currentWord][];
    for (int k = 0; k < currentWord; k++) {
      int sStart = splitOffsets[k][0];
      int sEnd = splitOffsets[k][1];
      int size = sEnd - sStart;
      split[k] = new char[size];
      System.arraycopy(array, sStart, split[k], 0, size);
    } 
    return split;
  }
  
  public static final char[][] subarray(char[][] array, int start, int end) {
    if (end == -1)
      end = array.length; 
    if (start > end)
      return null; 
    if (start < 0)
      return null; 
    if (end > array.length)
      return null; 
    char[][] result = new char[end - start][];
    System.arraycopy(array, start, result, 0, end - start);
    return result;
  }
  
  public static final char[] subarray(char[] array, int start, int end) {
    if (end == -1)
      end = array.length; 
    if (start > end)
      return null; 
    if (start < 0)
      return null; 
    if (end > array.length)
      return null; 
    char[] result = new char[end - start];
    System.arraycopy(array, start, result, 0, end - start);
    return result;
  }
  
  public static final char[] toLowerCase(char[] chars) {
    if (chars == null)
      return null; 
    int length = chars.length;
    char[] lowerChars = null;
    for (int i = 0; i < length; i++) {
      char c = chars[i];
      char lc = ScannerHelper.toLowerCase(c);
      if (c != lc || lowerChars != null) {
        if (lowerChars == null)
          System.arraycopy(
              chars, 
              0, 
              lowerChars = new char[length], 
              0, 
              i); 
        lowerChars[i] = lc;
      } 
    } 
    return (lowerChars == null) ? chars : lowerChars;
  }
  
  public static final char[] toUpperCase(char[] chars) {
    if (chars == null)
      return null; 
    int length = chars.length;
    char[] upperChars = null;
    for (int i = 0; i < length; i++) {
      char c = chars[i];
      char lc = ScannerHelper.toUpperCase(c);
      if (c != lc || upperChars != null) {
        if (upperChars == null)
          System.arraycopy(
              chars, 
              0, 
              upperChars = new char[length], 
              0, 
              i); 
        upperChars[i] = lc;
      } 
    } 
    return (upperChars == null) ? chars : upperChars;
  }
  
  public static final char[] trim(char[] chars) {
    if (chars == null)
      return null; 
    int start = 0, length = chars.length, end = length - 1;
    while (start < length && chars[start] == ' ')
      start++; 
    while (end > start && chars[end] == ' ')
      end--; 
    if (start != 0 || end != length - 1)
      return subarray(chars, start, end + 1); 
    return chars;
  }
  
  public static final String toString(char[][] array) {
    char[] result = concatWith(array, '.');
    return new String(result);
  }
  
  public static final String[] toStrings(char[][] array) {
    if (array == null)
      return NO_STRINGS; 
    int length = array.length;
    if (length == 0)
      return NO_STRINGS; 
    String[] result = new String[length];
    for (int i = 0; i < length; i++)
      result[i] = new String(array[i]); 
    return result;
  }
}
